

#property copyright "RickyD System by Shimodax"
#property link      ""


extern bool   OnlyEnterOnFullBars     = true;
extern bool   OnlyExitOnFullBars      = true;

extern bool   EnableTrailStopExit     = false;
extern int    InitialStopLossPoints   = 15;
extern int    TakeProfitPoints        = 50;
extern int    TrailStopTriggerPoints  = 15;
extern int    TrailStopPoints         = 15;


       int    ComboTriggerLevel       = 5;


#include "Z-BaseExpert.mqh"




//+------------------------------------------------------------------+
//|                                                                  |
//|  OPEN / CLOSE                                                    |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
int CheckForOpen(double &openlots, double &initialstoploss, double &initialtakeprofit, int &trailstoppoints, double &trailstopentry)
{
   static bool lasttradesignal= 0;
   bool errslope;
   int  res, doopen= 0,
        spreadpt= MathRound(Ask-Bid/Point),
        lookupidx= 0;

   double 
         graylevel, 
         greenlevel,
         redlevel,
         intrade,
         spread= , 
         openclose= MathAbs(Open[1]-Close[1]), 
         highlow= High[1]-Low[1], 
         result= 0;


   //---- no order on the same bar where we closed
   if (gTimeLastTradeClosed==Time[0]) 
      return (0);

         
   //---- go trading only for first tiks of new bar
   if (OnlyEnterOnFullBars) {
      if (Volume[0]>1) 
         return(0);
      else
         lookupidx= 1;  // look at the values of the previous bar (recently completed bar)
   }
   else {
      lookupidx= 0;
   }
   
   graylevel= iCustom(NULL, 0,  "RD-Combo", 0, lookupidx);
   redlevel= iCustom(NULL, 0,   "RD-Combo", 1, lookupidx);
   greenlevel= iCustom(NULL, 0, "RD-Combo", 2, lookupidx);
   intrade= iCustom(NULL, 0, "RD-Combo", 3, lookupidx); 

 
   if (greenlevel!=0) 
      result= greenlevel;
   else
   if (redlevel!=0) 
      result= redlevel;
   else
      result= 0;   

   if (DebugLogger)
      Print("Result =", result, " (combo: green= ", greenlevel, 
                  ", red= ", redlevel, ", gray= ", graylevel, 
                  ", intrade= ", intrade, ")");




   if (result==ComboTriggerLevel) {   // LONG
      doopen= OPENLONG;
      gExpectedEntry= Ask;
     
      if (EnableTrailStopExit) {
         if (TrailStopTriggerPoints!=0 && TrailStopPoints!=0) {
            trailstoppoints= TrailStopPoints;
            trailstopentry= Ask + TrailStopTriggerPoints*Point;
         }
         
         if (InitialStopLossPoints!=0)
            initialstoploss= Ask - InitialStopLossPoints*Point;
            
         if (TakeProfitPoints!=0) 
            initialtakeprofit= Ask + TakeProfitPoints*Point;
      }
   }

   if (result==-ComboTriggerLevel) {   // SHORT
      doopen= OPENSHORT;
      gExpectedEntry= Bid;
      
      if (EnableTrailStopExit) {
         if (TrailStopTriggerPoints!=0 && TrailStopPoints!=0) {
            trailstoppoints= TrailStopPoints;
            trailstopentry= Bid - TrailStopTriggerPoints*Point;
         }
         
         if (InitialStopLossPoints!=0)
            initialstoploss= Bid + InitialStopLossPoints*Point;
            
         if (TakeProfitPoints!=0) 
            initialtakeprofit= Bid - TakeProfitPoints*Point;
      }
   }

   return(doopen);
}

  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CheckForClose(int ticket, int ordertype, double &closelots, double stoploss, double takeprofit, string &reason)
{
   bool doclose= 0;
   int lookupidx= 0;
   

   if (OnlyExitOnFullBars) {
      if (Volume[0]>1)
         return(0);
      else
         lookupidx= 1;
   }

   int intrade= iCustom(NULL, 0, "RD-Combo", 3, lookupidx); 

   
   if (ordertype==OP_BUY && !intrade) {    // open buy order (until close below trailstop)

      reason= "gold signal " + intrade;
      if (gExpectedExit==0)
         gExpectedExit= Bid;
      doclose= TRUE;
   }

   if (ordertype==OP_SELL && !intrade) { // open sell order (until close above ema)

      reason= "gold signal " + intrade;
      if (gExpectedExit==0)
         gExpectedExit= Ask;
      doclose= TRUE;
   }
 
   return(doclose);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ManageStops(int ticket, int ordertype, int trailstopmode, 
                  double &currentstoploss, double &currenttakeprofit, int trailstoppoints, double trailstopentry)
{
   double entry= OrderOpenPrice();
   int n;
   
   if (ordertype==OP_BUY) {    // handle long order
      // currentstoploss= TrailStopNew(currentstoploss, Bid, gProfitTarget, ordertype, "rule 08/15");   
   }
   
   if (ordertype==OP_SELL) {    // handle short order
      // currentstoploss= TrailStopNew(currentstoploss, Bid, gProfitTarget, ordertype, "rule 08/15");   
   }
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
{

}

void OnDeInit()
{

}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
{

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnOrderOpen(int ticket, int ordertype, double lots)
{
 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnOrderClose(int ticket, int ordertype, double profit, double slippage, string reason)
{

}





